#include "common.h"
#include "gpl.h"

int
main (void)
{
  char *reservedZoneName;
  char *freeZoneName;
  char *charUID;
  int childPID;
  int exitStatus;

  init ();
  reservedZoneName = getReservedZoneName ();
  if (reservedZoneName != NULL)
    {
      destroy ();
      fprintf (stderr, "Error: %s is already allocated to you.\n",
	       reservedZoneName);
      fprintf (stderr, "To use the zone run: " ENTER_ZONE_CMD "\n");
      return -1;
    }
  freeZoneName = getFreeZoneName ();
  if (freeZoneName == NULL)
    {
      destroy ();
      fprintf (stderr, "Error: no free zones available.\n");
      return -1;
    }
  printf ("Reserving zone: %s\n", freeZoneName);
  reserveZone (freeZoneName);

  childPID = fork ();
  if (!childPID)
    {
      setreuid (0, 0);
      charUID = (char *) malloc (sizeof (char) * CONFIG_UID_LEN + 1);
      sprintf (charUID, "%d", uid);
      execl ("/etc/devzone/scripts/init_zone.sh", "", username, charUID,
	     (char *) NULL);
    }
  wait (&exitStatus);

  destroy ();

  return 0;
}
