#include "common.h"
#include "gpl.h"

int
main (void)
{
  char *reservedZoneName;
  char *charUID;
  pid_t childPID;
  int exitStatus;

  init ();
  reservedZoneName = getReservedZoneName ();
  if (reservedZoneName == NULL)
    {
      destroy ();
      fprintf (stderr, "Error: no zones are allocated to you.\n");
      return -1;
    }
  childPID = fork ();
  if (!childPID)
    {
      setreuid (0, 0);
      charUID = (char *) malloc (sizeof (char) * CONFIG_UID_LEN + 1);
      sprintf (charUID, "%d", uid);
      execl ("/etc/devzone/scripts/release_zone.sh", "", username, charUID,
	     (char *) NULL);
    }
  wait (&exitStatus);

  if (!freeZone (reservedZoneName))
    {
      destroy ();
      fprintf (stderr, "Error: could not free zone.\n");
      return -1;
    }
  printf ("Thank you, your zone is now free\n");

  destroy ();

  return 0;
}
